<? SESSION_START(); ?>                             <!-- Starting a session in PHP, which will be later used in accessing the session variables-->
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>jellybean</title>
    <link rel="stylesheet" href="css/styles.css">  <!-- Referencing styles.css file in the tittle section of html file for formatting and style the jellybean.php-->
</head>
<body>
    <h1>It's Fun To Play Jellybean Game,Let's Jump Into The Game</h1>
    <?php                                                     
    if(!ISSET($_POST['submit'])) {                    //The form has not been submitteds
      first_form();   
    }else{                                                 
        if(!ISSET($_SESSION['random_number'])){       //Random number has not been set      
        $x = $_POST['range'];                         //Assigning range value to $x 
        $range_error = validate($x,'ran');           //Calling function Validate to validate range value
            if(ISSET($range_error)){                 //Range value has validation errors
            echo "<div class='msgBox error'>";
            echo "<h2>Oh no!</h2>";
            foreach($range_error as $val){          //Display validation error messages  
                echo "<p>". $val . "</p>";
            }
            echo "</div>";
            first_form();
            unset($range_error);
            }else{                                        //If range value is validated,set the rando number here
            $range = intval($_POST['range']);             //User entered range is assigned to $range variable 
            $_SESSION['random_number'] = rand(0,$range);  //creates a random number between 0 and user specified range value
            guess_form();                                 //Ask user for their first guess  
            }
            }else{
            $y = $_POST['guess'];                         //Assigning guess value to $y
            if(ISSET($_SESSION['count_number'])){         //count is set,increment it
            $_SESSION['count_number']++;
            }else{
            $_SESSION['count_number'] = 1;                //count is not set,set it
            }
            $guess_error = validate($y,'gus');             //Calling function validate to validate guess value
            if(ISSET($guess_error)){                       //Guess value has validation errors 
            echo "<div class='msgBox error'>";
            echo "<h2>Oh no!</h2>";
            foreach($guess_error as $val){                 //Display validation errors
            echo "<p>". $val . "</p>";
            }
            echo "</div>";
            guess_form();
            unset($guess_error);
        }else{                                              //Random is set,then it comes to guessing block
            if($_POST['guess']<$_SESSION['random_number']){
            echo "<p> Your guess is too low.</p>";
            guess_form();
            }elseif($_POST['guess']>$_SESSION['random_number']){
            echo "<p> Your guess is too high</p>";
            guess_form();
            }else{ 
            echo "<p> Correct Guess </p>";
            echo "<p> Congratulations,You Won The Game!!!!! </p>";
            if($_SESSION['count_number'] == 1 ){
            echo "<p> Keep up the good work,It took you 1 attempt </p>";
            }else{
            echo "<p> It took you " . $_SESSION['count_number'] . " attempts</p>";
            }
            /*on correct guess resetting 
            random number,count number,destroying the existing session ,so that user can play new game */
            $_SESSION['random_number'] = null;              
            $_SESSION['count_number'] = null;                  
            session_destroy();
            echo "<p><a href='jellybean.php'>play again?</a></p>";
            }
            }
        } 
    } 
 
    function first_form(){
    ?>
    <form method ="post" action ="<?$_SERVER['PHP_SELF']?>">
    <p><label for="range">How many beans can be in the jar? </label><input type="text" name="range" id="range" placeholder="Enter a range"></p>
    <p><button type="submit" value="submit Range" name="submit">Start the game!</button></p>
    </form>
    <?
    }
    function guess_form(){
    ?>
    <form method ="post" action ="<?$_SERVER['PHP_SELF']?>">
    <p><label for="guess">What is ur guess:</label><input type="text" name="guess" id="guess" placeholder="guess a number" autofocus></p>
    <p><button type="submit" value="submit Guess" name="submit">Have a guess</button></p>
    </form>
    <?
    }
    function validate($data,$validation_type = 'text'){
    $data = trim($data);
    $error = null;
    $min_r = 1;
    $min_g = 0;                       
    $max = 9223372036854775807;
    if($validation_type == 'ran'){ 
        if (filter_var($data, FILTER_VALIDATE_INT, array("options" => array("min_range"=>$min_r, "max_range"=>$max))) == false){    
            $error[] = "Enter a valid number. ";
        }
        if($data==0){
           $error[] = "zero is not a valid number.";
        }
        if($data<0){
            $error[] = "value is either negative or no value is entered or its a special character.";
        }
        if($data > 9223372036854775807){
        $error[] = "Enter a value less then 9223372036854775807.";
    }
    }elseif($validation_type == 'gus'){
        if (filter_var($data, FILTER_VALIDATE_INT, array("options" => array("min_range"=>$min_g, "max_range"=>$max))) === false) {
        $error[] = " Enter a valid number. ";
        }
        if($data<0){ 
        $error[] = "value is either negative or no value is entered or special character";
        }
        if($data > 9223372036854775807){
        $error[] = "Enter a value less then 9223372036854775807.";
        }
    }
        return $error;   
    }
    ?>
</body>
</html>